package org.fouram.service;

import java.util.Iterator;

import org.fouram.core.base.service.BaseService;
import org.fouram.core.base.service.RequestService;
import org.fouram.core.util.JsonNodeUtil;
import org.fouram.entity.SapEmpTermination;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.fasterxml.jackson.databind.JsonNode;

@Service
public class SapEmpTerminationService extends BaseService {

	@Autowired
	private RequestService requestService;

	public void saveSapData() throws Exception {
		String url = "https://api15.sapsf.cn/odata/v2/EmpEmploymentTermination?$format=json";
		JsonNode node = requestService.getForObject(url, getHttpHeaders());
		if (node != null) {
			Iterator<JsonNode> iterator = node.get("d").get("results").elements();
			while (iterator.hasNext()) {
				JsonNode userNode = iterator.next();
				String userId = JsonNodeUtil.getValue(userNode, "userId");
				String endDate = JsonNodeUtil.getValue(userNode, "endDate");
				if(selectOneByUserId(userId) == null) {
					SapEmpTermination entity = SapEmpTermination.builder().userId(userId).endDate(endDate).build();
					save("SapEmpTerminationMapper.save", entity);
				}
			}
		}
	}

	public SapEmpTermination selectOneByUserId(String personId) throws Exception {
		return (SapEmpTermination) findObject("SapEmpTerminationMapper.selectOneByUserId", personId);
	}

	public void updateAllUserEndDate() throws Exception {
		update("SapEmpTerminationMapper.updateAllUserEndDate", null);
	}
}
