package org.fouram.service;

import java.util.List;

import org.fouram.core.base.service.BaseService;
import org.fouram.core.util.SplitUtil;
import org.fouram.dto.input.SapReportAuthDTO.SapReportAuthSaveDTO;
import org.fouram.dto.input.SapReportAuthDTO.SapReportAuthSelectListDTO;
import org.fouram.entity.SapReportAuth;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.alibaba.fastjson.JSONObject;

@Service
@Transactional
public class SapReportAuthService extends BaseService {

	public void save(SapReportAuthSaveDTO dto) throws Exception {
		List<Long> wxDepartIds = SplitUtil.splitToLong(dto.getWxDepartIds(), ",");
		for (Long wxDepartId : wxDepartIds) {
			SapReportAuth entity = SapReportAuth.builder().wxUserId(dto.getWxUserId()).wxDepartId(wxDepartId).build();
			save("SapReportAuthMapper.save", entity);
		}
	}

	@SuppressWarnings("unchecked")
	public JSONObject selectList(SapReportAuthSelectListDTO dto) throws Exception {
		dto.setPageCurrent(dto.getPageSize() * (dto.getPageNumber() - 1));
		List<SapReportAuth> pageList = (List<SapReportAuth>) findList("SapReportAuthMapper.selectList", dto);
		dto.setPageCurrent(null);
		List<SapReportAuth> allList = (List<SapReportAuth>) findList("SapReportAuthMapper.selectList", dto);
		return getPageResult(pageList, Long.valueOf(allList.size()));
	}

	public void deleteById(Long id) throws Exception {
		update("SapReportAuthMapper.deleteById", id);
	}

	@SuppressWarnings("unchecked")
	public List<SapReportAuth> selectListByWxUserId(String wxUserId) throws Exception {
		return (List<SapReportAuth>) findList("SapReportAuthMapper.selectListByWxUserId", wxUserId);
	}
}
